975. Odd Even Jump

You are given an integer arrayA. From some starting index, you can make a series of jumps. The (1st, 3rd, 5th, ...) jumps in the series are calledodd numbered jumps, and the (2nd, 4th, 6th, ...) jumps in the series are calledeven numbered jumps.

You may from indexi jump forward to indexj (withi < j) in the following way:

  • During odd numbered jumps (ie. jumps 1, 3, 5, ...), you jump to the index j such that A[i] <= A[j]and A[j]is the smallest possible value. If there are multiple such indexes j, you can only jump to the smallest such index j.
  • During even numbered jumps (ie. jumps 2, 4, 6, ...), you jump to the index j such that A[i] >= A[j]and A[j]is the largest possible value. If there are multiple such indexes j, you can only jump to the smallest such index j.
  • (It may be the case that for some index i,there are no legal jumps.)

A starting index is_good_if, starting from that index, you can reach the end of the array (indexA.length - 1) by jumping some number of times (possibly 0 or more than once.)

Return the number of good starting indexes.

Example 1:

Input: 
[10,13,12,14,15]
Output: 
2
Explanation: 

From starting index i = 0, we can jump to i = 2 (since A[2] is the smallest among A[1], A[2], A[3], A[4] that is greater or equal to A[0]), then we can't jump any more.
From starting index i = 1 and i = 2, we can jump to i = 3, then we can't jump any more.
From starting index i = 3, we can jump to i = 4, so we've reached the end.
From starting index i = 4, we've reached the end already.
In total, there are 2 different starting indexes (i = 3, i = 4) where we can reach the end with some number of jumps.

Example 2:

Input: 
[2,3,1,1,4]
Output: 
3
Explanation: 

From starting index i = 0, we make jumps to i = 1, i = 2, i = 3:

During our 1st jump (odd numbered), we first jump to i = 1 because A[1] is the smallest value in (A[1], A[2], A[3], A[4]) that is greater than or equal to A[0].

During our 2nd jump (even numbered), we jump from i = 1 to i = 2 because A[2] is the largest value in (A[2], A[3], A[4]) that is less than or equal to A[1].  A[3] is also the largest value, but 2 is a smaller index, so we can only jump to i = 2 and not i = 3.

During our 3rd jump (odd numbered), we jump from i = 2 to i = 3 because A[3] is the smallest value in (A[3], A[4]) that is greater than or equal to A[2].

We can't jump from i = 3 to i = 4, so the starting index i = 0 is not good.

In a similar manner, we can deduce that:
From starting index i = 1, we jump to i = 4, so we reach the end.
From starting index i = 2, we jump to i = 3, and then we can't jump anymore.
From starting index i = 3, we jump to i = 4, so we reach the end.
From starting index i = 4, we are already at the end.
In total, there are 3 different starting indexes (i = 1, i = 3, i = 4) where we can reach the end with some number of jumps.

Example 3:

Input: 
[5,1,3,4,2]
Output: 
3
Explanation: 

We can reach the end from starting indexes 1, 2, and 4.

Note:

  1. 1 <= A.length <= 20000
  2. 0 <= A[i] < 100000

Thoughts:

  1. DP: dp[i][0]: even jump at i; dp[i][1]: odd jump at i T:O(n^2)
  2. Sort + Stack to eliminate double for loop: keep stack monotonic decreasing as frogs jump to index monotonic increasing.

Code DP:

class Solution(object):
    def oddEvenJumps(self, A):
        """
        :type A: List[int]
        :rtype: int
        """
        n = len(A)
        odd = [-1] * n
        even = [-1] * n

        dp = [[0,0] for _ in range(n)] 
        dp[-1] = [1, 1]
        for i in range(n - 2, -1, -1):
            max_val, max_idx, min_val, min_idx = min(A[i + 1:]) - 1, -1, max(A[i + 1:]) + 1, -1
            for j in range(i + 1, n):
                if A[i] >= A[j] and A[j] > max_val:
                    max_idx = j 
                    max_val = A[j]
                if A[i] <= A[j] and A[j] < min_val:
                    min_idx = j
                    min_val = A[j]
            odd[i] = min_idx
            even[i] = max_idx

        ans = 1
        for k in range(n - 2, -1, -1):
            if even[k] != -1: 
                dp[k][0] = dp[even[k]][1] # even -> odd 
            if odd[k] != -1:
                dp[k][1] = dp[odd[k]][0] # odd -> even
            ans += dp[k][1]

        return ans

Code DP with stack optimization: T: O(nlogn)

class Solution:
    def oddEvenJumps(self, A: List[int]) -> int:
        n = len(A)
        # odd/even[i] -- start at i, next jump is odd/even
        odd, even = [False] * n, [False] * n
        odd[-1], even[-1] = True, True

        # sort by value then by index
        Asort = sorted([(x, i) for i, x in enumerate(A)])
        Asort_rev = sorted([(-x, i) for i, x in enumerate(A)])

        # find the jump-to location of each index
        oddjump = self.findjump(Asort)
        evenjump = self.findjump(Asort_rev)

        n_good = 1
        # try all starting locations, both odd and even
        # make one jump, use the solution of the jump-to location
        for i in range(n-2, -1, -1):  # n-1,n-2...1,0
            j = oddjump[i]
            if j is not None:
                odd[i] = even[j]
            # if j is None, then no legal jump

            j = evenjump[i]
            if j is not None:
                even[i] = odd[j]

            if odd[i]:
                n_good += 1
        return n_good

    def findjump(self, Asort):
        # monotonic stack
        stack = []
        # the jump-to index of each index
        jumpto = [None] * len(Asort)

        for _, i in Asort:
            # pop the indexes smaller than current
            # point th jump-to of these indexes to current
            while stack and stack[-1] < i:
                jumpto[stack.pop()] = i
            # push into stack
            stack.append(i)

        return jumpto

results matching ""

    No results matching ""